<?php

function st_header() {
	return <<<_END
<div id="x-panel-body x-panel-body-noheader x-panel-body-noborder">
<h2 id="modx-workspace-header" class="modx-page-header">Subtotal</h2>

_END;
}

function st_footer() {
	return <<<_END
</div>

_END;
}

function st_login_form() {
	return <<<_END
<form method=post>
<input type=hidden name=action value=login>
<p>Login: <input type=text name=login></p>
<p>Password: <input type=password name=password></p>
<p><input type=submit value='Login'></p>
</form>

_END;
	}

function st_main_form() {
	$logout_form = st_logout_form();
	$tabs_form = st_tabs_form();
	$select_business_form = st_select_business_form();
	$settings_form = st_settings_form();
	$import_form = st_import_form();

	if(!st_get_business()) {
		$settings_form = "";
		$import_form = "";
	}
	else if(!st_get_stock_store()) {
		$import_form = "";
	}

	return <<<_END
<div class=" x-tab-panel structure-tabs x-tab-panel-noborder">
$logout_form

$tabs_form

<div id=st_business>
$select_business_form
</div>
<div id=st_settings>
$settings_form
</div>
<div id=st_import>
$import_form
</div>
</div>

_END;
}

function st_logout_form() {
	$login = st_get_login();
	return <<<_END
<div>
<form method=post>
<input type=hidden name=action value=logout>
<p>Вы вошли как $login <input type=submit value='Logout'></p>
</form>
</div>

_END;
}

function st_tabs_form() {
	$business_tab = "<input type=button value='Выбор бизнеса' onClick='st_show_only_block(\"st_business\")'>";
	$settings_tab = "<input type=button value='Настройки' onClick='st_show_only_block(\"st_settings\")'>";
	$import_tab = "<input type=button value='Импорт' onClick='st_show_only_block(\"st_import\")'>";
	if(!st_get_business()) {
		$settings_tab = "";
		$import_tab = "";
	}
	else if(!st_get_stock_store()) {
		$import_tab = "";
	}
	return <<<_END
<div>
$import_tab
$settings_tab
$business_tab
</div>

_END;
}

function st_select_business_form() {
	$result = "";
	$shops_data = st_getShops();
	$business_id = st_get_business();
	$business_options = "";
	foreach($shops_data['shops'] as $shop_row) {
		$id = $shop_row['id'];
		$name = $shop_row['name'];
		if($id == $business_id) {
			$business_options .= "<option value='$id' selected>$name</option>\n";
		}
		else {
			$business_options .= "<option value='$id'>$name</option>\n";
		}
	}


	$result .= <<<_END
<div>
<form method=post>
<input type=hidden name=action value="select_business">
<p>Выберите бизнес:
<select name=business>
$business_options
</select>
<input type=submit value='Применить'>
</p>
</form>
</div>

_END;
	return $result;
}

function st_settings_form() {
	$result = "";

	$poses_data = st_getPoses();
	$prices_data = st_getPrices();
	$tags_data = st_getTags();
	$groups_data = st_get_groups_list();
	$templates_data = st_get_templates_list();
//var_dump($tags_data);

	$stock_store = st_get_stock_store();
	$import_limit_value = st_get_import_limit_value();
	$update_period = st_get_update_period();
	$import_price = st_get_import_price();
	$import_tags_list = st_get_import_tags_list();
	$import_to_group = st_get_import_to_group();
	$import_to_template = st_get_import_to_template();
	$update_stocks = st_get_update_stocks();
	$import_photos = st_get_import_photos();
	$import_description = st_get_import_description();
	$import_tags = st_get_import_tags();
	$import_auto_photos = st_get_import_auto_photos();
	$import_auto_description = st_get_import_auto_description();
	$import_auto_tags = st_get_import_auto_tags();
	$import_auto_name = st_get_import_auto_name();

	$import_tags_array = json_decode($import_tags_list);

	$poses_options = "";
	foreach($poses_data['poses'] as $pos_row) {
		$id = $pos_row['id'];
		$name = $pos_row['name'];
		if($id == $stock_store) {
			$poses_options .= "<option value='$id' selected>$name</option>\n";
		}
		else {
			$poses_options .= "<option value='$id'>$name</option>\n";
		}
	}

	$prices_options = "";
	foreach($prices_data['repricing_prices'] as $price_row) {
		$id = $price_row['id'];
		$name = $price_row['full_name'];
		if($id == $import_price) {
			$prices_options .= "<option value='$id' selected>$name</option>\n";
		}
		else {
			$prices_options .= "<option value='$id'>$name</option>\n";
		}
	}

	$import_tags_list_options = "";
	foreach($tags_data['tags'] as $tag_name) {
		$id = $tag_name;
		$name = $tag_name;
		if(is_array($import_tags_array) && in_array($id, $import_tags_array)) {
			$import_tags_list_options .= "<option value='$id' selected>$name</option>\n";
		}
		else {
			$import_tags_list_options .= "<option value='$id'>$name</option>\n";
		}
	}

	$import_to_group_options = "";
	foreach($groups_data as $id => $name) {
		if($import_to_group == $id) {
			$import_to_group_options .= "<option value='$id' selected>$name</option>\n";
		}
		else {
			$import_to_group_options .= "<option value='$id'>$name</option>\n";
		}
	}

	$import_to_template_options = "";
	foreach($templates_data as $id => $name) {
		if($import_to_template == $id) {
			$import_to_template_options .= "<option value='$id' selected>$name</option>\n";
		}
		else {
			$import_to_template_options .= "<option value='$id'>$name</option>\n";
		}
	}
//var_dump($import_tags_list, $import_tags_array, $import_tags_list_options);

	if($update_stocks) {
		$update_stocks_checkbox_value = "checked";
	}
	else {
		$update_stocks_checkbox_value = "";
	}

	if($import_photos) {
		$import_photos_checkbox_value = "checked";
	}
	else {
		$import_photos_checkbox_value = "";
	}

	if($import_description) {
		$import_description_checkbox_value = "checked";
	}
	else {
		$import_description_checkbox_value = "";
	}

	if($import_tags) {
		$import_tags_checkbox_value = "checked";
	}
	else {
		$import_tags_checkbox_value = "";
	}

	if($import_auto_photos) {
		$import_auto_photos_checkbox_value = "checked";
	}
	else {
		$import_auto_photos_checkbox_value = "";
	}

	if($import_auto_description) {
		$import_auto_description_checkbox_value = "checked";
	}
	else {
		$import_auto_description_checkbox_value = "";
	}

	if($import_auto_tags) {
		$import_auto_tags_checkbox_value = "checked";
	}
	else {
		$import_auto_tags_checkbox_value = "";
	}

	if($import_auto_name) {
		$import_auto_name_checkbox_value = "checked";
	}
	else {
		$import_auto_name_checkbox_value = "";
	}

	$result .= <<<_END
<div>
<style>
#st_form_table {
}

#st_form_table tr:nth-child(even) {
	background-color: lightgray;
}

#st_form_table td {
	padding-top: 0.1em;
	padding-bottom: 0.1em;
}
</style>
<form method=post>
<input type=hidden name=action value="settings">
<p>Настройте магазин, чтобы заказы привязывались к определенному магазину в Subtotal.</p>
<table id=st_form_table>
<tr>
<td>Точка продаж для синхронизации:</td>
<td><select name=stock_store>$poses_options</select></td>
</tr>
<tr>
<td><p>Период автообновления (минуты):</p>
<small>Через этот промежуток времени<br>
будут обновляться товары из базы subtotal</small>
</td>
<td><input type=number name=update_period value='$update_period'></td>
</tr>
<tr>
<td>Импортировать за раз товаров:</td>
<td><input type=number name=import_limit_value value='$import_limit_value'></td>
</tr>
<tr>
<td>Импортировать цены из прайса:</td>
<td><select name=import_price>$prices_options</select></td>
</tr>
<tr>
<td><p>Группы для импорта:</p>
<small>Для выбора нескольких групп<br>
используйте Ctrl или Shift.<br>
Если не выбрана ни одна группа,<br>
то будут импортироваться все группы.</small>
</td>
<td><select name=import_tags_list[] multiple>$import_tags_list_options</select></td>
</tr>
<tr>
<td>Импортировать товары в группу MODx:</td>
<td><select name=import_to_group>$import_to_group_options</select></td>
</tr>
<tr>
<td>Импортировать в шаблон MODx:</td>
<td><select name=import_to_template>$import_to_template_options</select></td>
</tr>
<!--<p style='display:none'>
<label>
<input type=checkbox name=update_stocks $update_stocks_checkbox_value>
Обновлять остатки
</label>
</p>-->
<tr>
<td colspan=2>
<p><b>Настройки ручного импорта</b></p>
<p>Эти настройки влияют на ручной импорт через вкладку "Импорт товаров" плагина</p>
</td>
</tr>
<tr>
<td colspan=2>
<label>
<input type=checkbox name=import_photos $import_photos_checkbox_value>
Импортировать фотографии
</label>
</td>
</tr>
<tr>
<td colspan=2>
<label>
<input type=checkbox name=import_description $import_description_checkbox_value>
Импортировать описания
</label>
</td>
</tr>
<tr>
<td colspan=2>
<label>
<input type=checkbox name=import_tags $import_tags_checkbox_value>
Импортировать группы subtotal в теги modx
</label>
</td>
</tr>
<tr>
<td colspan=2>
<b>Настройки автообновления товаров</b></p>
<p>Эти настройки влияют на обновление товаров по расписанию</p>
</td>
</tr>
<tr>
<td colspan=2>
<label>
<input type=checkbox name=import_auto_name $import_auto_name_checkbox_value>
Обновлять названия
</label>
</td>
</tr>
<tr>
<td colspan=2>
<label>
<input type=checkbox name=import_auto_tags $import_auto_tags_checkbox_value>
Обновлять группы
</label>
</td>
</tr>
<tr>
<td colspan=2>
<label>
<input type=checkbox name=import_auto_photos $import_auto_photos_checkbox_value>
Обновлять фотографии
</label>
</td>
</tr>
<tr>
<td colspan=2>
<label>
<input type=checkbox name=import_auto_description $import_auto_description_checkbox_value>
Обновлять описания
</label>
</tr>
</table>

<p><input type=submit value='Сохранить изменения'></p>
</form>
</div>

_END;
	return $result;
}

function st_wait_apply_form($redirect_uri) {
	return <<<_END
<p>Подождите, идёт обновление настроек...</p>
<script>
setTimeout(function() {
	window.location = '$redirect_uri'
}, 5000);
</script>

_END;
}

function st_import_form() {
	$goods_count = 0;

	$catalog = st_getCatalog();
	if($catalog) {
		$goods_count = count($catalog['goods']);
	}

	$prev_import_date_unixtime = st_get_prev_import_timestamp();
	$prev_import_date = date("H:i:s d.m.Y", $prev_import_date_unixtime);

	$import_limit_value = st_get_import_limit_value();
	return <<<_END
<p>Импорт товаров</p>
<p>Товары и услуги: $goods_count</p>
<form method=post>
<input type=hidden value='start_sync'>
<input type=hidden id=st_count value='$import_limit_value'>
<p>
<label>
<input type=checkbox id='only_new_products' checked>
Загрузить только новые товары
</label>
</p>
<p><input type=button value='Начать синхронизацию' onClick='return st_start_sync()' id=st_start_sync_button></p>
<p>
<textarea id=st_log cols=80 rows=10>
</textarea>
<p>Дата предыдущего фонового импорта: $prev_import_date</p>
</p>
</form>

_END;
}
