<?php

require_once("subtotal_api.php");
require_once("modx_api.php");
require_once("forms.php");
require_once("core.php");
require_once("sync.php");
require_once("functions.php");

/**
 * The home manager controller for subtotal.
 *
 */
class subtotalHomeManagerController extends modExtraManagerController
{
//    use SubtotalApiTrait;

    /** @var subtotal $subtotal */
    public $subtotal;


    /**
     *
     */
    public function initialize()
    {
        $this->subtotal = $this->modx->getService('subtotal', 'subtotal', MODX_CORE_PATH . 'components/subtotal/model/');
        parent::initialize();
    }


    /**
     * @return array
     */
    public function getLanguageTopics()
    {
        return ['subtotal:default'];
    }


    /**
     * @return bool
     */
    public function checkPermissions()
    {
        return true;
    }


    /**
     * @return null|string
     */
    public function getPageTitle()
    {
        return $this->modx->lexicon('subtotal');
    }


    /**
     * @return void
     */
    public function loadCustomCssJs()
    {
        $this->addCss($this->subtotal->config['cssUrl'] . 'mgr/main.css');
        $this->addJavascript($this->subtotal->config['jsUrl'] . 'mgr/subtotal.js');
        $this->addJavascript($this->subtotal->config['jsUrl'] . 'jquery-3.5.1.min.js');
        $this->addJavascript($this->subtotal->config['jsUrl'] . 'mgr/functions.js');
        //$this->addJavascript($this->subtotal->config['jsUrl'] . 'mgr/misc/utils.js');
        //$this->addJavascript($this->subtotal->config['jsUrl'] . 'mgr/misc/combo.js');
        //$this->addJavascript($this->subtotal->config['jsUrl'] . 'mgr/widgets/items.grid.js');
        //$this->addJavascript($this->subtotal->config['jsUrl'] . 'mgr/widgets/login.grid.js');
        //$this->addJavascript($this->subtotal->config['jsUrl'] . 'mgr/widgets/items.windows.js');
        //$this->addJavascript($this->subtotal->config['jsUrl'] . 'mgr/widgets/home.panel.js');
        //$this->addJavascript($this->subtotal->config['jsUrl'] . 'mgr/sections/home.js');

        /*$this->addHtml('<script type="text/javascript">
        subtotal.config = ' . json_encode($this->subtotal->config) . ';
        subtotal.config.connector_url = "' . $this->subtotal->config['connectorUrl'] . '";
        Ext.onReady(function() {MODx.load({ xtype: "subtotal-page-home"});});
        </script>');*/
    }


    /**
     * @return string
     */
    public function getTemplateFile() {
        if($_POST['action']) {
            if($_POST['action'] == 'login') {
                $login = $_POST['login'];
                $password = $_POST['password'];
                $auth_result = st_auth($login, $password);
//var_dump($auth_result);
                $session = $auth_result['session'];
                if($auth_result['data']['status'] == '200') {
                    st_set_session($session);
                    st_set_login($login);
                    st_set_owner($auth_result['data']['last_owner']);
                }
		else {
		    $this->content .= "Ошибка авторизации";
		}
            }
            else if($_POST['action'] == 'logout') {
                st_set_session('');
                st_set_login('');
                st_set_owner('');
            }
            else if($_POST['action'] == 'select_business') {
                $business = $_POST['business'];
                st_set_business($business);
                st_set_owner("id$business");
            }
            else if($_POST['action'] == 'settings') {
                st_set_stock_store($_POST['stock_store']);
                st_set_import_limit_value($_POST['import_limit_value']);
                st_set_update_period($_POST['update_period']);
                st_set_import_price($_POST['import_price']);
                st_set_import_tags_list(json_encode($_POST['import_tags_list']));
                st_set_import_to_group($_POST['import_to_group']);
                st_set_import_to_template($_POST['import_to_template']);
                st_set_update_stocks($_POST['update_stocks']? "1": "0");
                st_set_import_photos($_POST['import_photos']? "1": "0");
                st_set_import_description($_POST['import_description']? "1": "0");
                st_set_import_tags($_POST['import_tags']? "1": "0");
                st_set_import_auto_photos($_POST['import_auto_photos']? "1": "0");
                st_set_import_auto_description($_POST['import_auto_description']? "1": "0");
                st_set_import_auto_tags($_POST['import_auto_tags']? "1": "0");
                st_set_import_auto_name($_POST['import_auto_name']? "1": "0");
		st_create_tv_variables();
            }
            else if($_POST['action'] == 'sync') {
		$page_size = $_POST['page_size'];
		$page_num = $_POST['page_num'];
		if(rand(0,10) == 5) {
			$done = 1;
			$count = rand(0, $page_size);
		}
		else {
			$done = 0;
		}

		header("Content-type: application/json");
		$result = st_importProducts($page_num);
		echo json_encode($result);
                st_reset_cache();
                die();
            }
            else {
                die("Unknown method for subtotal\n");
            }
            st_reset_cache();
            $this->content .= st_wait_apply_form($_SERVER['REQUEST_URI']);
        }
	else {
	        $session = st_get_option("subtotal_session");
	        $this->content .= st_header();
	        if($session) {
	            $this->content .= st_main_form();
	        }
	        else {
	            $this->content .= st_login_form();
	        }
		if($_GET['debug']) {
			$this->content .= "Debug:<br>\n";
			global $modx, $table_prefix;
			$query_select = "SELECT `name`,`description` FROM `${table_prefix}subtotal_items` WHERE 1";
        		$res = $modx->prepare($query_select);
        		$res->execute();
			while($data = $res->fetch(PDO::FETCH_ASSOC)) {
				$key = $data['name'];
				$val = $data['description'];
				$this->content .= "$key => $val<br>\n";
			}
			$this->content .= "End<br>\n";

		}
	}
        return '';
    }
}

