<?php

class subtotalItemCreateProcessor extends modObjectCreateProcessor
{
    public $objectType = 'subtotalItem';
    public $classKey = 'subtotalItem';
    public $languageTopics = ['subtotal'];
    //public $permission = 'create';


    /**
     * @return bool
     */
    public function beforeSet()
    {
        $name = trim($this->getProperty('name'));
        if (empty($name)) {
            $this->modx->error->addField('name', $this->modx->lexicon('subtotal_item_err_name'));
        } elseif ($this->modx->getCount($this->classKey, ['name' => $name])) {
            $this->modx->error->addField('name', $this->modx->lexicon('subtotal_item_err_ae'));
        }

        return parent::beforeSet();
    }

}

return 'subtotalItemCreateProcessor';