function st_log_clear() {
	$("#st_log").val("");
}

function st_log_append(str) {
	let log_text = $("#st_log").val();
	let d = new Date();
	let time = d.toLocaleTimeString();
	$("#st_log").val("[" + time + "] " + str + "\n" + $("#st_log").val());
}

function st_start_sync() {
	let page_size = $("#st_count").val();
	if(!page_size) {
		page_size = 20;
	}
	let only_new_products = $("#only_new_products").prop('checked');
	let page_num = 1;
	$("#st_start_sync_button").prop("disabled", true);
	window.onbeforeunload = function() {
		return "Did you save your stuff?"
	};
	st_log_clear();
	st_log_append("Синхронизация запущена");
	st_continue_sync(page_size, page_num, only_new_products, 0);
	return false;
}

function st_continue_sync(page_size, page_num, only_new_products, synced = 0) {
	page_size = parseInt(page_size);
	page_num = parseInt(page_num);
	let query = {
		"action": "sync",
		"page_num": page_num,
		"page_size": page_size,
		"only_new_products": only_new_products,
	};
	$.post(window.location, query)
		.done(function(reply) {
			if(reply.done == 0) {
				synced += parseInt(reply.count);
				st_log_append("Синхронизировано " + synced + " товаров");
				setTimeout(function() {
					st_continue_sync(page_size, page_num + 1, only_new_products, synced);
				}, 1000);
			}
			else {
				//st_log_append("Синхронизировано " + synced + " товаров");
				st_log_append("Синхронизация завершена");
				$("#st_start_sync_button").prop("disabled", false);
				window.onbeforeunload = null;
			}
		})
		.fail(function(reply) {
			st_log_append("Ошибка синхронизации " + synced + " товаров, повтор через 5 секунд...");
			setTimeout(function() {
				st_continue_sync(page_size, page_num, only_new_products, synced);
			}, 5000);
		});
}

function st_show_only_block(block_id) {
	let blocks = ["st_business", "st_settings", "st_import"];
	blocks.forEach(function(cycle_block) {
		if(cycle_block == block_id) {
			$("#" + cycle_block).show();
		}
		else {
			$("#" + cycle_block).hide();
		}
	});
}

$(function() {
	if($("#st_import").text().trim() != '') st_show_only_block("st_import");
	else if($("#st_settings").text().trim() != '') st_show_only_block("st_settings");
	else if($("#st_business").text().trim() != '') st_show_only_block("st_business");
});
